POJ 2482 Stars in Your Window 线段树

2024-04-23 20:32
文章标签 window poj 线段 stars 2482

本文主要是介绍POJ 2482 Stars in Your Window 线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题意:每一颗星星有一定的亮度值,现在坐标系中有许多星星,每个星星的坐标及亮度值已经给定,求一个矩形能够框住的最大值。Lazy 标记。

题解:对每一颗星星,画出以它为左下角的矩形,这个矩形就是它的影响范围。为了方便处理,我们将每一颗星分作两颗,
frist_star ( x, y, val ),  second_star ( x + w, y, -val ),这样当我们不断插入星星的时候,其实就相当于有一个矩形框在从左往右移动,因为碰到 first_star 则总亮度加上 val 说明框住了星星,碰到 second_star 则再加上 -val, 那么 val + (-val ) = 0, 相当于没有框住星星。 那么,我们每插入一颗星就得到一个 x 轴范围固定,但是 y 轴范围不定的矩形(也就是两条扫描线,因为矩形上下两边不定)。如此便只需要维护 y 坐标这一个变量了,让 [ y, y + h ] 这一区间加上val, 用线段树求得此时刻的最大值。当所有星星都插入完成,得到的最大值也就是我们要求的值了。

           另外有一点需要注意,不能加上矩形边上的点。(我想原意应该是星星本身要加,以星星为左下角的矩形的其他边上的星星则不加)。因此对节点排序时便要注意了,当 x 相同的时候切记 val 小的要放在前面!否则求的的最大值就有可能包含边上点的。

#include <iostream>
using namespace std;
#define lint __int64
#define N 1000000
lint y[N];
struct item
{
lint x, y, v;
} point[N];
struct line
{
lint l, r, sum, add;
} node[N];
int ycmp ( const void* a, const void* b )
{
return *(lint*)a - *(lint*)b;
}
int pcmp ( const void *a, const void *b )
{
item *ta = (item*)a;
item *tb = (item*)b;
if ( ta->x == tb->x )
return ta->v - tb->v; /* 注意 val 为负则放在前面, 否则会加上边界的点 */
return ta->x - tb->x;
}
lint max ( lint a, lint b )
{
return a > b ? a : b;
}
void build_tree ( lint left, lint right, lint u )
{
node[u].l = left;
node[u].r = right;
node[u].sum = node[u].add = 0;
if ( left == right ) return;
lint mid = ( left + right ) / 2;
build_tree ( left, mid, u * 2 );
build_tree ( mid + 1, right, u * 2 + 1 );
}
int bfind ( lint l, lint r, lint key )
{
while ( l <= r )
{
int mid = ( l + r ) / 2;
if ( y[mid] == key )
return mid;
if ( key < y[mid] )
r = mid - 1;
else if ( key > y[mid] )
l = mid + 1;
}
return 0;
}
void update ( lint l, lint r, lint val, lint u )
{	
if ( l <= node[u].l && node[u].r <= r )
{
node[u].add += val;
node[u].sum += val;
return;
}
if ( node[u].add != 0 )
{
node[u*2].add += node[u].add;
node[u*2].sum += node[u].add;
node[u*2+1].add += node[u].add;
node[u*2+1].sum += node[u].add;
node[u].add = 0;
}
lint mid = ( node[u].l + node[u].r ) / 2;
if ( r <= mid )
update ( l, r, val, u * 2 );
else if ( l > mid )
update ( l, r, val, u * 2 + 1 );
else
{
update ( l, mid, val, u * 2 );
update ( mid + 1, r, val, u * 2 + 1 );
}
node[u].sum = max ( node[u*2].sum, node[u*2+1].sum ); 
}
int main()
{
lint n, w, h, i, cnt, ans;
//freopen("a.txt","r",stdin);
while ( scanf("%I64d%I64d%I64d",&n,&w,&h ) != EOF )
{
for ( i = 1; i <= n; ++i )
{
scanf("%I64d%I64d%I64d",&point[i].x, &point[i].y, &point[i].v );
y[i] = point[i].y;
y[n+i] = point[i].y + h;
point[n+i].x = point[i].x + w;
point[n+i].y = point[i].y;
point[n+i].v = -point[i].v;
}
qsort ( y+1, 2*n, sizeof(y[1]), ycmp );
qsort ( point+1, 2*n, sizeof(point[1]), pcmp);
for ( i = cnt = 1; i <= 2 * n; ++i )
{
if ( y[cnt] != y[i] )
y[++cnt] = y[i];
}
build_tree ( 1, cnt, 1 );
ans = 0;
for ( i = 1; i <= 2 * n; ++i )
{
lint left = bfind ( 1, cnt, point[i].y );
lint right = bfind ( 1, cnt, point[i].y + h ) - 1;
if ( left > right ) swap(left,right);
update ( left, right, point[i].v, 1 );
ans = max ( ans, node[1].sum );
}
printf ( "%I64d\n", ans );
}
return 0;
}


这篇关于POJ 2482 Stars in Your Window 线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/929807

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D